unit Pform;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Tabs, regfake, buttons, fedutils,
  Scroll, JPSplitr, utils, Newtab, TabLabel;

type
  TPalette = class(TForm)
    _PaletteArea: TPScrollBox;
    JPSplitter2: TJPSplitter;
    TabSet: TNewtabs;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TopScrollBoxAlignControls(Sender: TObject);
    procedure _PaletteAreaAlignControls(Sender: TObject);
    procedure TopScrollBoxEnter(Sender: TObject);
    procedure TopScrollBoxExit(Sender: TObject);
    procedure TabSetClick(Sender: TObject);
  private
    { Private declarations }
  protected
    FCurrentPalette : TPScrollBox;
    Function GetHint(AClass : TClass) : String;
  public
    { Public declarations }
    ActiveSpeedButton : TSpeedButton;
    Procedure CreateComponentBar;
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure OnComponentClick(Sender: TObject);
    Procedure ReleaseAllButtons;
    Procedure TabLabelClick(Sender : TObject);
    Procedure SectionLabelClick(Sender : TObject);
  end;

var
  Palette: TPalette;

implementation

{$R *.DFM}

uses main;

procedure TPalette.CreateComponentBar;
var
  LTop, MLeft, MTop : Integer;
  PageIndex, ComponentIndex : Integer;
  Page : TRegistrationPage;
  SpeedButton : TSpeedButton;
  ComponentClass : TComponentClass;
  SectionLabel : TTabLabel;
{  TabLabel : TTabLabel;}
  PalettePage : TPScrollBox;
  Index : Integer;
begin
  { now create pages etc }
  PageIndex:=0;
  MTop:=4;
  LTop:=0;
  While PageIndex<RegistrationPages.PageCount do begin
  MTop:=0;

    Page:=RegistrationPages.GetPage(PageIndex);

    PalettePage:=TPScrollBox.Create(Self);

    PalettePage.Align:=alClient;
    PalettePage.Visible:=False;
    PalettePage.OnAlignControls:=_PaletteAreaAlignControls;
    PalettePage.BorderStyle:=bsNone;
    PalettePage.Parent:=Self;

    SectionLabel:=TTabLabel.Create(Self);
    SectionLabel.ParentFont:=True;
    SectionLabel.Caption:=Page.Name;
    SectionLabel.Parent:={PaletteArea}PalettePage;
    SectionLabel.Selected:=True;
    MLeft:=0;
    SectionLabel.Left:=MLeft;
    SectionLabel.Top:=MTop;
    SectionLabel.GroupIndex:=11;

    Inc(MTop,SectionLabel.Height);

{    TabLabel:=TTabLabel.Create(Self);
    TabLabel.ParentFont:=True;
    TabLabel.Caption:=Page.Name;
    TabLabel.Top:=LTop;
    Inc(Ltop,TabLabel.Height);
    TabLabel.Parent:=TopScrollBox;
    TabLabel.Tag:=longint(SectionLabel);
    TabLabel.OnClick:=TabLabelClick;
    TabLabel.GroupIndex:=11;}
    Index:=TabSet.Tabs.AddObject(Page.Name,SectionLabel);

    SectionLabel.Tag:=Index;
    SectionLabel.OnClick:=SectionLabelClick;

    If FCurrentPalette=nil then begin
      FCurrentPalette:=PalettePage;
      SectionLabel.Down:=True;
{      TabLabel.Down:=True;}
      TabSet.ItemIndex:=Index; 
    end;

    ComponentIndex:=0;
    While ComponentIndex<Page.ComponentCount do begin
      ComponentClass:=Page.GetComponent(ComponentIndex);
      SpeedButton:=TSpeedButton.Create(Self);
      SpeedButton.Parent:={PaletteArea}PalettePage;
      SpeedButton.Width:=SpeedButton.Width+4;
      SpeedButton.Height:=SpeedButton.Height+4;
      If (MLeft+SpeedButton.Width)>{PaletteArea}PalettePage.Width then begin
        MLeft:=0;
        Inc(MTop,SpeedButton.Height);
      end;
      SpeedButton.Left:=MLeft;
      SpeedButton.Top:=MTop;
      Inc(MLeft,SpeedButton.Width);

      SpeedButton.Glyph.Handle:=Page.GetBitmap(ComponentIndex);
      SpeedButton.Hint:=GetHint(ComponentClass);
      SpeedButton.OnClick:=OnComponentClick;
      SpeedButton.Tag:=Longint(ComponentClass);
      SpeedButton.ShowHint:=True;
      SpeedButton.AllowAllUp:=True;
      SpeedButton.GroupIndex:=PaletteGroupIndex;

      With TLabel.Create(Self) do begin
        Parent:={PaletteArea}PalettePage;
        Caption:=NiceClassName(ComponentClass);
        Left:=MLeft;
        Top:=MTop;
        Height:=SpeedButton.Height;
        WordWrap:=true;
        MLeft:=0;
        Inc(Mtop,SpeedButton.Height);
      end;

      inc(componentIndex);
    end;
    inc(PageIndex);
    inc(Mtop,SpeedButton.Height);
    MLeft:=0;
  end;
  If FCurrentPalette<>nil then
    FCurrentPalette.Visible:=True;

{  TabSet.tabs:=NoteBook.Pages;
  TabSet.TabIndex:=0;
  NoteBook.PageIndex:=0;
  TabSet.OnChange:=TabSet1Change;
  TabSet.Tag:=longint(NoteBook);}

{  PageIndex:=0;
  While PageIndex<RegistrationPages.PageCount do begin
    Page:=RegistrationPages.GetPage(PageIndex);
    If PageIndex<NoteBook.Pages.Count then
      NoteBook.Pages[PageIndex]:=Page.Name
    else
      NoteBook.Pages.Add(Page.Name);
    ComponentIndex:=0;
    While ComponentIndex<Page.ComponentCount do begin
      ComponentClass:=Page.GetComponent(ComponentIndex);
      SpeedButton:=TSpeedButton.Create(Self);
      SpeedButton.Parent:=TWinControl(NoteBook.Pages.Objects[PageIndex]);
      SpeedButton.Width:=SpeedButton.Width+4;
      SpeedButton.Height:=SpeedButton.Height+4;
      SpeedButton.Top:=3;
      If (ComponentIndex mod 2)=1 then SpeedButton.Top:=SpeedButton.Top+SpeedButton.Height;
      SpeedButton.Left:=3+(ComponentIndex div 2)*(SpeedButton.Width);
      SpeedButton.Glyph.Handle:=Page.GetBitmap(ComponentIndex);
      SpeedButton.Hint:=NiceClassName(ComponentClass); { drop the T
      SpeedButton.OnClick:=OnComponentClick;
      SpeedButton.Tag:=Longint(ComponentClass);
      SpeedButton.ShowHint:=True;
      SpeedButton.AllowAllUp:=True;
      SpeedButton.GroupIndex:=PaletteGroupIndex;
      inc(componentIndex);
    end;
    inc(PageIndex);
  end;
  TabSet.tabs:=NoteBook.Pages;
  TabSet.TabIndex:=0;
  NoteBook.PageIndex:=0;
  TabSet.OnChange:=TabSet1Change;
  TabSet.Tag:=longint(NoteBook);}
end;

procedure TPalette.FormCreate(Sender: TObject);
begin
  CreateComponentBar;
  { Make sure tabset fits some rows exactly with no half rows }
  TabSet.height:=(TabSet.Height div TabSet.ItemHeight)*TabSet.ItemHeight+2;
end;

procedure TPalette.OnComponentClick;
begin
  RTDPMainForm_CSL.OnComponentClick(Sender);
end;

procedure TPalette.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  ReleaseAllButtons;
  TNoteBook((Sender as TTabSet).Tag).PageIndex:=NewTab;
end;

procedure TPalette.ReleaseAllButtons;
begin
  try
    If ActiveSpeedButton<>nil then
      ActiveSpeedButton.Down:=False;
  finally
    ActiveSpeedButton:=nil;
  end;
end;

procedure TPalette.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caMinimize;
end;

Procedure TPalette.TabLabelClick;
var
  TabLabel : TTabLabel;
  SectionLabel : TTabLabel;
begin
(*  TabLabel:=(Sender as TTabLabel);
  TopScrollBox.ScrollInView(TabLabel);
  SectionLabel:=TTabLabel(TabLabel.Tag);
  SectionLabel.Down:=True;
  If FCurrentPalette<>nil then begin
    FCurrentPalette.Visible:=False;
    FCurrentPalette.Collapse;
  end;
  FCurrentPalette:={PaletteArea}(SectionLabel.Parent as TPScrollBox);
  With {PaletteArea}FCurrentPalette do begin
    Visible:=True;
    VertScrollbar.Position:=VertScrollbar.Position+SectionLabel.Top;
  end;*)
end;

Procedure TPalette.sectionLabelClick;
var
  TabLabel : TTabLabel;
  SectionLabel : TTabLabel;
begin
  SectionLabel:=(Sender as TTabLabel);
  {PaletteArea}(SectionLabel.Parent as TPScrollBox).ScrollInView(SectionLabel);
  TabSet.ItemIndex:=SectionLabel.Tag;
{  TabLabel:=TTabLabel(SectionLabel.Tag);
  TabLabel.Down:=True;}
{  With TopScrollBox.VertScrollbar do
    Position:=Position+TabLabel.Top-TopScrollBox.Height+TabLabel.Height+1;}
end;

procedure TPalette.TopScrollBoxAlignControls(Sender: TObject);
var
  Rect : TRect;
  control : TControl;
  C, W : Integer;
begin
(*  With TopScrollBox do begin
{    Rect:=Bounds(-HorzScrollBar.Position, -VertScrollBar.Position,
      Max(HorzScrollBar.Range-HorzScrollBar.Page, ClientWidth),
      Max(ClientHeight, VertScrollBar.Range-VertScrollBar.Page));
    W:=Rect.Right-Rect.Left;}
    W:=ClientWidth;
    C:=0; while c<ControlCount do begin
      Control:=Controls[c];
      If Control is TTabLabel then
        Control.Width:=W;
      inc(c);
    end;
  end;*)
end;

procedure TPalette._PaletteAreaAlignControls(Sender: TObject);
var
  Rect : TRect;
  control : TControl;
  C, W, L : Integer;
begin
  With (Sender as TPScrollBox) do begin
{    Rect:=Bounds(-HorzScrollBar.Position, -VertScrollBar.Position,
      Max(HorzScrollBar.Range-HorzScrollBar.Page, ClientWidth),
      Max(ClientHeight, VertScrollBar.Range-VertScrollBar.Page));
    W:=Rect.Right-Rect.Left;}
    W:=ClientWidth;
    L:=HorzScrollBar.Position;
    C:=0; while c<ControlCount do begin
      Control:=Controls[c];
      If Control is TTabLabel then
        With Control do Width:=W;
      inc(c);
    end;
  end;
end;

procedure TPalette.TopScrollBoxEnter(Sender: TObject);
begin
  messagebeep(word(-1));
end;

procedure TPalette.TopScrollBoxExit(Sender: TObject);
begin
  messagebeep(word(-1));
end;

Function TPalette.GetHint;
begin
  Result:='';
  While AClass<>TObject do begin
    Result:=RTDPMainForm_CSL.MapFile.ReadString('PaletteHints',AClass.Classname,'');
    If Result<>'' then break;
    AClass:=AClass.ClassParent;
  end;
end;

procedure TPalette.TabSetClick(Sender: TObject);
var
  SectionLabel : TTabLabel;
begin
{  TopScrollBox.ScrollInView(TabLabel);}
  SectionLabel:=TTabLabel(TabSet.Tabs.Objects[TabSet.ItemIndex]);
  SectionLabel.Down:=True;
  If FCurrentPalette<>nil then begin
    FCurrentPalette.Visible:=False;
    FCurrentPalette.Collapse;
  end;
  FCurrentPalette:={PaletteArea}(SectionLabel.Parent as TPScrollBox);
  With {PaletteArea}FCurrentPalette do begin
    Visible:=True;
    VertScrollbar.Position:=VertScrollbar.Position+SectionLabel.Top;
  end;
end;

end.

